local BlobWriter, BlobReader = require('BlobWriter'), require('BlobReader')

local writer, reader = BlobWriter(), BlobReader(" ")

return {
	description = 'Blob',

	serialize = {
		sequentialManyNumbers = function(data)
			return writer:clear():array('number', data):tostring()
		end,

		sequentialManyU32 = function(data)
			return writer:clear():array('u32', data):tostring()
		end,

		sequentialFewNumbers = function(data)
			return writer:clear():array('number', data):tostring()
		end,

		sequentialFewU8 = function(data)
			return writer:clear():array('u8', data):tostring()
		end,

		deepTable = function(data)
			return writer:clear():table(data):tostring()
		end,
	},

	deserialize = {
		sequentialManyNumbers = function(data)
			return reader:reset(data):array('number')
		end,

		sequentialManyU32 = function(data)
			return reader:reset(data):array('u32')
		end,

		sequentialFewNumbers = function(data)
			return reader:reset(data):array('number')
		end,

		sequentialFewU8 = function(data)
			return reader:reset(data):array('u8')
		end,

		deepTable = function(data)
			return reader:reset(data):table()
		end,
	}
}
